; File:     Calcula14.asm
; by:       RuiLoureiro
;
                        include     Calcula14.glb

      ;include   \masm32\macros\macros.asm         ; masm32 macro file                        
      ;include    \masm32\include\masm32.inc     ; masm32 library include
      ;includelib \masm32\lib\masm32.lib         ; masm32 static library
      ;include    \masm32\include\msvcrt.inc
      ;includelib \masm32\lib\msvcrt.lib

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;       unsigned integers: from -4 294 967 295 = - FFFFFFFFh to
;                                4 294 967 295 = + FFFFFFFFh
;
;       1  - Take the expression from expression, remove all spaces
;             and put it into buffer. Remove return and line feed also.
;             Count the number of characters
;
;       2  - Get a copy of buffer to NewBuffer
;
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$SIGN1$         equ 0
$OPR1$          equ 4
$SIGN2$         equ 8
$OPR2$          equ 12

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.data
_StrTooLong     db "Operand too long", 0
_StrEspress     db "This is your expression: ", 0
_StrOperandO    db "Operand overflow ", 0
_StrResult      db "This is your Result:  ", 0
_StrOverflow    db "Overflow", 0
_StrDivision    db "Division by 0", 0
_StrLine        db "---------------------------------------------", 0
;-----------------------------    
    intro1      db "It does Sub(-), Add(+), Mul(*), Div(/) and Remainder(\)",13, 10, 0
    intro2      db "It uses integers from -4 294 967 295 to 4 294 967 295 ",13,10,13,10, 0
    
    
    request     db "Type an expression and press enter [ ex: -2 + 3*(7 - 2*8) ]",13,10, 0   ; screen output
    
    expression  db 81 dup(0)            
                dd 0

                dd 82
                dd 0
    buffer      db 82 dup (0)
                dd 0

                dd 83
                dd 0
    NewBuffer   db 83 dup (0)
                dd 0    

    Signal      dd 0                ; +=0  -=1
    Operation   dd 0                ;1=-   2=+   3=*   4=/  5=\

    _Sign       dd 0                ; +=0  -=1
                dd LENOPERAND
                dd 0
    _Operand    db LENOPERAND dup(0)             
                dd 0
                
    SignW       dd 0
    OperandW    dd 0

    _IsAt       dd 0
;---

                dd LENOPERAND
                dd 0
    ResultZ     db LENOPERAND dup(0)
                dd 0

                dd 80
                dd 0
    ExpBuffer   db 80 dup (0)
                db 0

                dd 15
                dd 0
    VarBuffer   db 16 dup (0)                
;...........................
                dd 5
_ERROR          db "ERROR"

                dd 15
_ERROR2         db "ResolveIt ERROR"

                dd 8
_OVERFLOW       db "OVERFLOW"
 
_RTLF           db 13, 10, 0    

                dd 30
                dd 0
_TestBuf        db 31 dup (0)
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    _OffsetFst  dd 0
    _OffsetLst  dd 0
     OffsetFst  dd 0
     OffsetLst  dd 0

                dd 200
                dd 0
    AuxBuffer   db 200 dup (0)
                dd 0

                dd 80
                dd 0
    WrkBuffer   db 80 dup (0)
                dd 0
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                dd 200
                dd 0
    _TblOperand dd 201 dup (0)
                dd 201 dup (0)
                dd 201 dup (0)
                dd 201 dup (0)

                dd 200
                dd 0
  _TblOperation dd 200 dup (0)

                dd 200
                dd 0
  _TblOperandAt dd 200 dup (0)
                dd 200 dup (0)
                
        _NoAnt  dd 0
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.code
start: 

                invoke      StandardOut, ADDR intro1
                invoke      StandardOut, ADDR intro2                

       main:    invoke      StandardOut, ADDR request         ; display request on screen
                invoke      StandardIn,  ADDR expression, LENGTHOF expression

                call        RemoveSpace
                jz          short start

                invoke      CpyRclRcl, addr buffer, addr NewBuffer

                invoke      PrintString, addr _StrEspress
                invoke      PrintStringLF, addr buffer

                call        IniExpress

                invoke      LookExpress, addr NewBuffer
                ;jc          _error
                
_error:         call        GetExpress
                
                invoke      PrintString, addr _StrResult 
                invoke      PrintStringLF, addr ResultZ
                
                invoke      PrintStringLF, addr ExpBuffer
                invoke      PrintStringLF, addr _StrLine
                jmp         main
; 
GetExpress      proc

                mov     esi, offset buffer
                mov     edi, offset ExpBuffer
                call    RclRclCpy
                ;
                mov     ecx, dword ptr [edi - 4]
                mov     byte ptr [edi + ecx], '='
                add     ecx, 1
                mov     dword ptr [edi - 4], ecx

                invoke  RclRclAdd, addr ResultZ, addr ExpBuffer
 
                ret
GetExpress      endp
; 
IniExpress      proc

                mov     edx, offset ExpBuffer
                mov     byte ptr [edx], 0
                mov     dword ptr [edx - 4], 0
                
                mov     edx, offset ResultZ
                mov     byte ptr [edx], 0
                mov     dword ptr [edx - 4], 0
                ret
IniExpress      endp 
;--------------------------------------------------------
SetError        proc
                push    esi
                push    edi

                mov     esi, offset _ERROR
                mov     edi, offset ResultZ
                ;
                call    RclRclCpy
                pop     edi
                pop     esi
                ret
SetError        endp
;--------------------------------------------------------
SetError2       proc
                push    esi
                push    edi

                mov     esi, offset _ERROR2
                mov     edi, offset ResultZ
                ;
                call    RclRclCpy
                pop     edi
                pop     esi
                ret
SetError2       endp
;--------------------------------------------------------
SetOverflow     proc
                push    esi
                push    edi
                
                mov     esi, offset _OVERFLOW
                mov     edi, offset ResultZ
                ;
                call    RclRclCpy
                pop     edi
                pop     esi
                ret
SetOverflow     endp
; 
RemoveSpace     proc

                mov     esi, offset expression
                mov     edi, offset buffer
                mov     dword ptr [edi - 4], 0
                mov     byte ptr [edi], 0
                
                xor     ecx, ecx
                jz      short next

@@:             cmp     al, 13
                je      short _exit                 ; return ?
                cmp     al, 10
                je      short _exit                 ; line feed ?

                cmp     al, 20h
                je      short next
                                
                mov     byte ptr [edi + ecx], al
                add     ecx, 1
                ;
next:           movzx   eax, byte ptr [esi]
                add     esi, 1
                
                cmp     al, 0
                jne     short @B
                
_exit:          mov     dword ptr [edi - 4], ecx
                mov     byte ptr [edi + ecx], 0

                or      ecx, ecx
                ret
RemoveSpace     endp
; 
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
RemSpaces       proc    pRcl:DWORD
                push    esi
                push    edi

                mov     esi, [esp + 12]                 ;pRcl
                mov     ecx, dword ptr [esi - 4]
                ;
                mov     edi, offset AuxBuffer
                mov     dword ptr [edi - 4], 0
                xor     ebx, ebx
                xor     edx, edx
                ;
   _loop:       movzx   eax, byte ptr [esi + edx]
                add     edx, 1

                cmp     al, 20h
                je      short @F
                                
                mov     byte ptr [edi + ebx], al
                add     ebx, 1
                ;                
       @@:      sub     ecx, 1
                jnz     short _loop
                
                mov     dword ptr [esi - 4], ebx
                mov     byte ptr [esi + ebx], 0
                
                cmp     ebx, 0
                je      short _exit
                ;
       @@:      sub     ebx, 1
                movzx   eax, byte ptr [edi + ebx]
                mov     byte ptr [esi + ebx], al
                jnz     short @B 
                                
    _exit:      pop     edi
                pop     esi
                ret     4
RemSpaces       endp
;
RemExpress      proc    pRcl:DWORD
                push    esi
                push    edi

                mov     esi, [esp + 12]                 ;pRcl
                mov     ecx, dword ptr [esi - 4]
                ;
                mov     edi, offset AuxBuffer
                mov     dword ptr [edi - 4], 0
                xor     ebx, ebx

                mov     eax, _OffsetFst
                add     eax, esi
                mov     OffsetFst, eax
                ;
                mov     eax, _OffsetLst
                add     eax, esi
                mov     OffsetLst, eax
                
   _loop1:      cmp     esi, OffsetFst 
                je      short _next1
                
                movzx   eax, byte ptr [esi]
                add     esi, 1
                                
                mov     byte ptr [edi + ebx], al
                add     ebx, 1
                mov     dword ptr [edi - 4], ebx
                ;                
                sub     ecx, 1
                jnz     short _loop1
                stc
                jc      _exit
                ;
                ; Replace by AT
                ; 
    _next1:     mov     byte ptr [edi + ebx], '@'
                add     ebx, 1
                mov     dword ptr [edi - 4], ebx
                ;
                mov     esi, OffsetLst
                ;
    _loop2:     add     esi, 1
                movzx   eax, byte ptr [esi]

                cmp     al, 0
                je      _next2
                
                mov     byte ptr [edi + ebx], al
                add     ebx, 1
                mov     dword ptr [edi - 4], ebx
                jmp     _loop2
;---                
    _next2:     mov     ebx, dword ptr [edi - 4]

                mov     esi, [esp + 12]                 ;pRcl

                mov     dword ptr [esi - 4], ebx
                mov     byte ptr [esi + ebx], 0
                ;
       @@:      sub     ebx, 1
                movzx   eax, byte ptr [edi + ebx]
                mov     byte ptr [esi + ebx], al
                jnz     short @B 
                                
    _exit:      pop     edi
                pop     esi
                ret     4
RemExpress      endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef
;
AdjustSign      proc
                mov     edx, _OffsetFst
                cmp     edx, 0
                jne     short @F
                ret
                
    @@:         sub     edx, 1
                movzx   eax, byte ptr [esi + edx]
                cmp     al, '-'
                je      short @F
                ret
                
    @@:         mov     byte ptr [esi + edx], '+'
    
                cmp     dword ptr SignW, 0        ; 0 = +     1 = -
                je      short @F
                ;
                mov     dword ptr SignW, 0        ; 0 = +     1 = -                
                ret
                ;
    @@:         mov     dword ptr SignW, 1        ; 0 = +     1 = -                
                ret
AdjustSign      endp
;
;   _TblOperandAt is an array of 2 dwords to save sign 
;                 and result of each operation  (each @)
;
LookExpress     proc    pRcl:DWORD

                mov     edx, offset _TblOperandAt
                mov     dword ptr [edx - 4], 0
                ;
    _start:     mov     esi, pRcl
                mov     ecx, dword ptr [esi - 4]
                ;
                cmp     ecx, 0
                jne     short _loop1
                ;
    error1:     call    SetError
                stc
                ret
                
    _loop1:     sub     ecx, 1
                cmp     byte ptr [esi + ecx],')'
                je      short _found1
                ;
                cmp     ecx, 0
                jne     short _loop1
                ;
                ; not found
                ; 

;#################
;call    DebugExp2
;#################

                invoke      SolveExpress, esi
                clc
                ret            
;---
    _found1:    cmp     ecx, 0
                je      short error1
                ;
                mov     _OffsetLst, ecx
;---
    _loop2:     sub     ecx, 1
                movzx   eax, byte ptr [esi + ecx]
                cmp     al, '('
                je      short _found2
                
                cmp     al, ')'
                je      short _found1
                
                cmp     ecx, 0
                jne     short _loop2
                je      error1
;---
    _found2:    mov     _OffsetFst, ecx

                mov     ebx, _OffsetLst
                sub     ebx, ecx
                sub     ebx, 1
                
                cmp     ebx, 0
                je      short _rem
                ;
                cmp     ebx, 1
                ja      short _found3
                ;
                ; Constant
                ;
                movzx   eax, byte ptr [esi + ecx + 1]

                cmp     al, '@'
                je      short _rem
                
                cmp     al, '0'
                jb      error1
                
                cmp     al, '9'
                ja      error1
                ;
                ; Remove ()
                ; 
      _rem:     mov     ebx, _OffsetFst
                mov     byte ptr [esi + ebx], 20h
                mov     ebx, _OffsetLst
                mov     byte ptr [esi + ebx], 20h
                invoke  RemSpaces, esi
                jmp     _start
;---------------------------------------
    _found3:    mov     edi, offset WrkBuffer

                push    esi
                
                add     esi, ecx        ; _OffsetFst
                add     esi, 1

                mov     dword ptr [edi - 4], ebx
                mov     byte ptr [edi + ebx], 0
                
        @@:     sub     ebx, 1                
                movzx   eax, byte ptr [esi + ebx]
                mov     byte ptr [edi + ebx], al
                jnz     short @B

                pop     esi

                ; 
                ;     Wrk is constant ?
                ; 
                invoke  VrfOperand, edi, [edi - 4]
                jnc     _rem                            ; yes
                
                cmp     eax, 1
                je      error1
                ;
                ; Operation
                ; 
                invoke  SolveExpress, edi
                jc      error1
                ; 
                ;     Replace by AT
                ; 
                invoke  RemExpress, esi

                call    AdjustSign

                call    SaveAt
;#################
;call    DebugExp1
;#################
                jmp     _start
LookExpress     endp
;
SaveAt          proc
                push    edi
                
                mov     edx, SignW
                mov     eax, OperandW

                mov     edi, offset _TblOperandAt
                mov     ebx, dword ptr [edi - 4]                

                push    ebx
                shl     ebx, 3
                mov     dword ptr [edi + ebx + 0], edx        ; SignW
                mov     dword ptr [edi + ebx + 4], eax
                pop     ebx
                
                add     ebx, 1
                mov     dword ptr [edi - 4], ebx

                pop     edi
                ret
SaveAt          endp
;
RetrieveAt      proc
                push    edi
                
                mov     edi, offset _TblOperandAt
                mov     ebx, dword ptr [edi - 4]
                cmp     ebx, 0
                je      short _erro
                ;
                sub     ebx, 1
                
                push    ebx
                ;
                shl     ebx, 3                
                mov     edx, dword ptr [edi + ebx + 0]        ; SignW
                mov     eax, dword ptr [edi + ebx + 4]        ; OperandW
                ;
                pop     ebx
                mov     dword ptr [edi - 4], ebx
                
                clc
                pop     edi
                ret                

    _erro:      mov     eax, 0
                mov     edx, 0
                stc
                pop     edi
                ret
RetrieveAt      endp
;
SeeAt           proc
                pushfd
                pushad

;                call    DebugY

                mov     edi, offset _TblOperandAt
                xor     ebx, ebx

;                invoke  DebugRcl3, [edi - 4], [edi - 4]
                
    _loop1:     cmp     ebx, dword ptr [edi - 4]
                jae     short _fim
                ;
                push    ebx
                shl     ebx, 3
                mov     edx, dword ptr [edi + ebx + 0]        ; SignW
                mov     eax, dword ptr [edi + ebx + 4]        ; OperandW

;                invoke  DebugRcl4, edx, eax
                pop     ebx
                ;
                add     ebx, 1
                jmp     _loop1

_fim:           ;call    DebugY
                    
                popad
                popfd
                ret
SeeAt           endp
;
; Output:
;           clc:    constant
;
;           stc:    EAX = 0   not constant
;                       = 1   erro
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
VrfOperand      proc    pRcl:DWORD, Len:DWORD
                push    esi
                
                mov     esi, [esp + 8]             ; pRcl
                mov     ecx, [esp + 12]            ; Len
                cmp     ecx, 0
                jne     short @F
                
    erro:       mov     eax, 1
                stc
                pop     esi
                ret     8
               
      @@:       xor     ebx, ebx
                ;
                movzx   eax, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                ;
                mov     _Sign, 1                
                cmp     al, '-'
                je      next1

                mov     _Sign, 0
                cmp     al, '+'
                je      next1
                ;
                cmp     al, '@'
                je      short _not
                ;
                cmp     al, '0'
                jb      erro
                cmp     al, '9'
                ja      erro

Isdigit1:       cmp     ebx, LENOPERAND
                je      erro
                
                add     ebx, 1
;..................
next1:          cmp     ecx, 0
                jne     short @F
                ;
                ; Is constant
                ; 
                clc
                pop     esi                
                ret     8
;---                
        @@:     movzx   eax, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1

                cmp     al, '@'
                je      short IsAt

                cmp     al, '0'
                jb      short _not
                
                cmp     al, '9'
                jbe     short Isdigit1          ; is digit
                
    _not:       mov     eax, 0
                stc
                pop     esi                
                ret     8

     IsAt:      cmp     ebx, 0
                je      short _not
                jne     erro                
VrfOperand      endp
;OPTION PROLOGUE:PrologueDef 
;OPTION EPILOGUE:EpilogueDef 
;
;OPTION PROLOGUE:NONE 
;OPTION EPILOGUE:NONE 
OperationAB     proc    Sin1:DWORD, Opr1:DWORD, Sin2:DWORD, Opr2:DWORD, Opr:DWORD
                push    ebx
                
                mov     eax, [esp + 8]          ;Sin1
                mov     dl, al
                mov     eax, [esp + 16]         ;Sin2
                mov     dh, al
                
                movzx   eax, dl                
                mov     dword ptr SignW, eax        ; 0 = +     1 = -

                mov     ebx, [esp + 12]         ;Opr1
                mov     ecx, [esp + 20]         ;Opr2

                mov     eax, [esp + 24]         ;Opr

                    cmp     eax, 3
                    jae     _case3

                    cmp     eax, 2
                    je      short _case2

                        mov     al, 1
                                                
                        cmp     dh, 0
                        je      short @F

                        mov     al, 0
                        
                @@:     mov     dh, al
                
          _case2:       cmp     dl, dh                      ; Add
                        je      short _add
                        
                        cmp     ebx, ecx
                        jae     short _sub
                        ;
                        movzx   eax, dh
                        mov     dword ptr SignW, eax        ; 0 = +     1 = -
                        xchg    ebx, ecx
                        
           _sub:        sub     ebx, ecx
                        jmp     _exit
                        
           _add:        add     ebx, ecx
                        jc      erro1                        
                        jnc     _exit
                        
          _case3:       mov     dword ptr SignW, 0 ; 0 = +     1 = -

                        cmp     dl, dh
                        je      short @F

                        mov     dword ptr SignW, 1 ; 0 = +     1 = -

              @@:   cmp     eax, 3                  ; Mul
                    jne     _case4          

                        mov     eax, ebx
                        mul     ecx
                        jc      erro1
                        
                        mov     ebx, eax

                    jmp     _exit                        
          _case4:   cmp     eax, 4                  ; Div
                    jne     _case5
                    
                        cmp     ecx, 0
                        je      erro2

                        xor     edx, edx
                        mov     eax, ebx
                        div     ecx
                        mov     ebx, eax

                    jmp     _exit                                                
          _case5:   cmp     eax, 5                  ; Remainder
                    jne     erro2

                        cmp     ecx, 0
                        je      erro2

                        xor     edx, edx                        
                        mov     eax, ebx
                        div     ecx
                        mov     ebx, edx

_exit:          mov     OperandW, ebx
                clc
                pop     ebx
                ret     20
                
erro1:          call    SetOverflow
                pop     ebx
                ret     20
erro2:          call    SetError
                pop     ebx
                ret     20
OperationAB     endp
;OPTION PROLOGUE:PrologueDef 
;OPTION EPILOGUE:EpilogueDef 
;
;OPTION PROLOGUE:NONE 
;OPTION EPILOGUE:NONE 
SolveExpress    proc    pRcl:DWORD
                push    esi
                ;
                mov     esi, [esp + 8]
                mov     ecx, dword ptr [esi - 4]

                ; If expression starts with 2 signs
                ; remove one
                call    SolveSign
                jc      error

                mov     edx, offset _TblOperand
                mov     dword ptr [edx - 4], 0

                mov     edx, offset _TblOperation
                mov     dword ptr [edx - 4], 0

                mov     edx, offset ResultZ
                mov     dword ptr [edx - 4], 0                
                                
                invoke  GetOperandY, addr _Operand, addr _Sign, addr Operation
                jc      error

                cmp     _IsAt, 1
                je      IsAt1
                
                cmp     ecx, 0
                je      _exit           ; Operation = 0
;---
                invoke  CnvToDW, addr _Operand
                jc      _overflow
                                
                invoke  SetFstOperand, _Sign, eax
                call    SetOperation
                jmp     _next

    IsAt1:      cmp     ecx, 0
                je      ExitAt
                
                call    SetOperation
                call    PutFstOperand    
                jc      error

;---
    _next:      invoke  GetOperandY, addr _Operand, addr _Sign, addr Operation
                jc      error
                ;
                cmp     _IsAt, 1
                je      short IsAt2
                
                cmp     ecx, 0
                je      _stop           ; Operation = 0
                                
                invoke  CnvToDW, addr _Operand
                jc      _overflow
                
                invoke  SetNxtOperand, _Sign, eax

                call    SetOperation
                jc      error
                
                jmp     short _next
;-----------------------------------
    IsAt2:      cmp     ecx, 0
                je      short @F        ; Operation = 0
                
                call    PutNxtOperand
                jc      error
                
                call    SetOperation
                jc      error
                jnc     short _next
                
        @@:     call    PutNxtOperand
                jc      error
                       
                jmp     _solve
;-----------------------------------
    _stop:      invoke  CnvToDW, addr _Operand
                jc      _overflow
                
                invoke  SetNxtOperand, _Sign, eax

_solve:     
                call    SetLstOperand

                ;##########################
                ;call    SeeOperation
                ;##########################

                call    ResolveIt 
                
                pop     esi
                ret     4

    _exit:      mov     esi, [esp + 8]
                invoke  CpyRclRcl, esi, addr ResultZ
                     
                pop     esi
                ret     4

     error:     call    SetError
                stc
                pop     esi
                ret     4

    _overflow:  call     SetOverflow
                stc
                pop     esi
                ret     4
                
    ExitAt:     invoke  ToRclCnv, SignW, OperandW, addr ResultZ
                ;
                pop     esi
                ret     4
SolveExpress    endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef
;
SolveSign       proc
                cmp     ecx, 2
                ja      short @F
                ;
   _Ok:         clc
                ret
                ;
    @@:         movzx   eax, byte ptr [esi + 0]
                movzx   edx, byte ptr [esi + 1]
                cmp     al, '+'
                je      short _plus
                cmp     al, '-'
                jne     short _Ok
                ;
                ; AL = -
                ;
                cmp     dl, '+'
                je      short _minus
                cmp     dl, '-'
                jne     short _Ok

                mov     byte ptr [esi + 1], '+'
                je      short _rem
    
    _minus:     mov     byte ptr [esi + 1], '-'
                je      short _rem
;---***---
        
    _plus:      cmp     dl, '+'
                je      short _rem
                cmp     dl, '-'
                jne     short _Ok
                

    _rem:       cmp     byte ptr [esi + 2], '+'
                je      short error
                ;
                cmp     byte ptr [esi + 2], '-'
                je      short error

                mov     byte ptr [esi + 0], 20h
                add     esi, 1                                
                sub     ecx, 1
                clc
                ret
                ;
    error:      stc   
                ret
SolveSign       endp
;
SeeOperation    proc
                pushfd
                pushad

                mov     esi, offset _TblOperation
                mov     ecx, dword ptr [esi - 4]

                mov     edi, offset _TblOperand
                mov     edx, dword ptr [edi - 4]

;                invoke  DebugRcl4, ecx, edx
                ;
                xor     ebx, ebx
    _loop1:     push    ebx
                
                    shl     ebx, 4
                    add     ebx, offset _TblOperand
                    mov     ecx, dword ptr [ebx + $SIGN1$]
                    mov     edx, dword ptr [ebx + $OPR1$]

;                    invoke  DebugRcl3, ecx, edx
                    
                    mov     ecx, dword ptr [ebx + $SIGN2$]
                    mov     edx, dword ptr [ebx + $OPR2$]

;                    invoke  DebugRcl4, ecx, edx

                pop     ebx
                ;
                add     ebx, 1
                cmp     ebx, dword ptr [edi - 4]
                jb      _loop1
;------------------
                xor     ebx, ebx
    _loop2:     push    ebx
    
                    mov     ecx, dword ptr [esi + ebx*4]

;                    invoke  DebugRcl9, ecx

                pop     ebx
                ;
                add     ebx, 1
                cmp     ebx, dword ptr [esi - 4]
                jb      _loop2

;                    call    DebugX
                    
                popad
                popfd
                ret
SeeOperation    endp
;
SetOperation    proc
                push    edi
                
                mov     eax, Operation

                mov     edi, offset _TblOperation
                mov     ebx, dword ptr [edi - 4]
                mov     dword ptr [edi + ebx*4], eax
                add     ebx, 1
                
                cmp     ebx, dword ptr [edi - 8]
                ja      short @F                

                mov     dword ptr [edi - 4], ebx
                
                clc
                pop     edi
                ret
                ;
    @@:         stc                
                pop     edi
                ret                
SetOperation    endp
;
SetLstOperand   proc
                
                mov     edx, offset _TblOperation
                mov     eax, dword ptr [edx - 4]

                mov     edx, offset _TblOperand
                mov     dword ptr [edx - 4], eax
                                
                ret
SetLstOperand   endp
;
SetFstOperand   proc    Sign:DWORD, Opr:DWORD

                mov     eax, Opr
                mov     edx, Sign
                ;
                mov     ebx, offset _TblOperand
                mov     dword ptr [ebx + $SIGN1$], edx
                mov     dword ptr [ebx + $OPR1$], eax

                mov     dword ptr [ebx - 4], 1
                ;
                ret
SetFstOperand   endp
;
SetNxtOperand   proc    Sign:DWORD, Opr:DWORD
                push    edi
                ;
                mov     eax, Opr
                mov     edx, Sign
                
                mov     edi, offset _TblOperand
                mov     ebx, dword ptr [edi - 4]
                shl     ebx, 4
                add     ebx, edi
                ;
                mov     dword ptr [ebx + $SIGN1$], edx
                mov     dword ptr [ebx + $OPR1$], eax                 
;---
                mov     ebx, dword ptr [edi - 4]
                sub     ebx, 1
                shl     ebx, 4
                add     ebx, edi
                ;
                mov     dword ptr [ebx + $SIGN2$], edx
                mov     dword ptr [ebx + $OPR2$], eax
;---
                mov     ebx, dword ptr [edi - 4]
                add     ebx, 1
                mov     dword ptr [edi - 4], ebx

                pop     edi
                ret
SetNxtOperand   endp
;
PutFstOperand   proc

                call    RetrieveAt

                ;mov     eax, OperandW
                ;mov     edx, SignW
                ;
                mov     ebx, offset _TblOperand
                mov     dword ptr [ebx + $SIGN1$], edx
                mov     dword ptr [ebx + $OPR1$], eax

                mov     dword ptr [ebx - 4], 1
                ;
                ret
PutFstOperand   endp
;
PutNxtOperand   proc
                push    edi
                ;
                call    RetrieveAt
                jc      _erro
                
                ;mov     eax, OperandW
                ;mov     edx, SignW
                
                mov     edi, offset _TblOperand
                mov     ebx, dword ptr [edi - 4]
                shl     ebx, 4
                add     ebx, edi
                ;
                mov     dword ptr [ebx + $SIGN1$], edx
                mov     dword ptr [ebx + $OPR1$], eax                 
;---
                mov     ebx, dword ptr [edi - 4]
                sub     ebx, 1
                shl     ebx, 4
                add     ebx, edi
                ;
                mov     dword ptr [ebx + $SIGN2$], edx
                mov     dword ptr [ebx + $OPR2$], eax
;---
                mov     ebx, dword ptr [edi - 4]
                add     ebx, 1
                mov     dword ptr [edi - 4], ebx
                clc
                
    _erro:      pop     edi
                ret
PutNxtOperand   endp
; 
; Input:
;           ESI     - pBufer
;           ECX     - buffer length
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE     
GetOperandY     proc    pOpr:DWORD, oSign:DWORD, pOper:DWORD

                mov     _IsAt, 0

                cmp     ecx, 0
                jne     short @F
                
   _erro:       stc
                ret     12
;................. Operand 1 ............... 
               
@@:             mov     edi, [esp + 4]              ; pOpr      Operand
                mov     edx, [esp + 8]              ; oSign     Sign
                mov     ebx, [esp + 12]             ; pOper     Operation

                mov     dword ptr [ebx], 0
                mov     dword ptr [edi - 4], 0
                ;
                xor     ebx, ebx
                
                movzx   eax, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                ;
                mov     dword ptr [edx], 1
                cmp     al, '-'
                je      _next1

                mov     dword ptr [edx], 0               
                cmp     al, '+'
                je      _next1
                ;
                cmp     al, '@'
                jne     short @F
                ;
                mov     _IsAt, 1
                je      IsAt1     
                ;
        @@:     cmp     al, '0'
                jb      _erro
                cmp     al, '9'
                ja      _erro

   _Isdigit1:   cmp     ebx, LENOPERAND
                je      _erro
                ;
                mov     byte ptr [edi + ebx], al
                add     ebx, 1                
                mov     dword ptr [edi - 4], ebx                                
;..................
   _next1:      cmp     ecx, 0
                je      _exit

                movzx   eax, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1

                cmp     al, '@'
                jne     short @F
                
                mov     _IsAt, 1
                je      IsAt2     

        @@:     cmp     al, '0'
                jb      short @F
                
                cmp     al, '9'
                jbe     short _Isdigit1            ; is digit
                
;................. Operation ...............

    @@:         mov     edx, [esp + 12]             ; pOper
                call    IsOperation
                jne     _erro
                
;................. Operand 2 ...............
                cmp     ecx, 0
                je      _erro
                ; 
                ; Termina com operao 
                ; Falta prximo operando
                ; 
                clc             
                ret     12
                ; 
                ; Termina com operando 
                ;       ECX = 0
                ; 
   _exit:       cmp     ebx, 0
                je      _erro
   
        @@:     clc
                ret     12
;---***---
    IsAt1:      mov     _IsAt, 1
    
    ExitAt:     cmp     ecx, 0
                je      short @B
                ;                       
                ;................. Operation ...............
                movzx   eax, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                                
                mov     edx, [esp + 12]             ; pOper
                call    IsOperation
                jne     _erro

                cmp     ecx, 0
                je      _erro
                
                clc
                ret     12
                
;---***---      sign + AT

    IsAt2:      mov     _IsAt, 1
                cmp     ebx, 0
                je      short ExitAt
                jne     _erro
GetOperandY     endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
;
IsOperation     proc

                mov     dword ptr [edx], 1          ; Sub
                cmp     al, '-'
                je      short @F
                mov     dword ptr [edx], 2          ; Add
                cmp     al, '+'
                je      short @F
                mov     dword ptr [edx], 3          ; Mul
                cmp     al, '*'
                je      short @F
                mov     dword ptr [edx], 4          ; Div
                cmp     al, '/'
                je      short @F
                mov     dword ptr [edx], 5          ; Rem
                cmp     al, '\'
                je      short @F

    @@:         ret
IsOperation     endp
;
ResolveIt       proc

                mov     esi, offset _TblOperation
                xor     ebx, ebx

    _loop1:     mov     edi, offset _TblOperand
                mov     edx, dword ptr [esi + ebx*4]
                cmp     edx, 3
                jb      short _next1
                ;
                push    ebx
                    shl     ebx, 4
                    invoke  OperationAB,[edi + ebx + $SIGN1$], [edi + ebx + $OPR1$], 
                                        [edi + ebx + $SIGN2$], [edi + ebx + $OPR2$], edx
                pop     ebx
                jc      _end

                mov     dword ptr [esi + ebx*4], 0

                call    SaveAntRes
                call    SaveNxtRes
                jnc     short _next1
                ;
                cmp     _NoAnt, 0
                je      _Ok                 ; FIM
                ;
    _next1:     add     ebx, 1
                cmp     ebx, dword ptr [esi - 4]
                jb      short _loop1
    ;---***---
                xor     ebx, ebx

    _loop2:     mov     edi, offset _TblOperand
                mov     edx, dword ptr [esi + ebx*4]
                cmp     edx, 0
                je      short _next2
                ;
                push    ebx
                    shl     ebx, 4
                    invoke  OperationAB,[edi + ebx + $SIGN1$], [edi + ebx + $OPR1$], 
                                        [edi + ebx + $SIGN2$], [edi + ebx + $OPR2$], edx
                pop     ebx
                jc      _end
                
                call    SaveNxtRes
                jnc     short _next2
                ;
                ; END
                ; 
    _Ok:        invoke  ToRclCnv, SignW, OperandW, addr ResultZ
                clc
                ret
                ;
    _next2:     add     ebx, 1
                cmp     ebx, dword ptr [esi - 4]
                jb      short _loop2
                ; 
                ; It cannot end HERE
                ; 
                call    SetError2
                stc    
    _end:       ret
ResolveIt       endp
;
SaveAntRes      proc
                push    ebx

                mov     _NoAnt, 0
                ;
    _next:      cmp     ebx, 0
                je      short _no
                ;
                sub     ebx, 1
                cmp     dword ptr [esi + ebx*4], 0
                je      short _next
                ;
                shl     ebx, 4
                add     ebx, offset _TblOperand

                mov     eax, SignW
                mov     edx, OperandW
                mov     dword ptr [ebx + $SIGN2$], eax
                mov     dword ptr [ebx + $OPR2$], edx

                mov     _NoAnt, 1
 
                clc
                pop     ebx
                ret
                ;
    _no:        stc
                pop     ebx
                ret
SaveAntRes      endp
;
SaveNxtRes      proc
                push    ebx
                ;
                mov     edx, dword ptr [esi - 4]
                sub     edx, 1
                
    _next:      cmp     ebx, edx
                jae     short _no
                ;
                add     ebx, 1
                cmp     dword ptr [esi + ebx*4], 0
                je      short _next
                ;
                shl     ebx, 4
                add     ebx, offset _TblOperand

                mov     eax, SignW
                mov     edx, OperandW
                mov     dword ptr [ebx + $SIGN1$], eax
                mov     dword ptr [ebx + $OPR1$], edx
 
                clc
                pop     ebx
                ret
                ;
    _no:        stc
                pop     ebx
                ret
SaveNxtRes      endp
;
                    ;include     Debug.asm
                    include     Calcula14.inc
;........................................................
end   start   
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
