; File:     Calcula14.inc
; by:       RuiLoureiro
;--------------------------------------------------------
; The strings must be defined like this:
;                                           dd X
;                                           dd 0
;                                   string  db X+1 dup (0)
;
RclRclCpy       proc

                mov     ecx, dword ptr [esi - 4]
                cmp     ecx, dword ptr [edi - 8]
                jbe     short @F
                ;
                mov     ecx, dword ptr [edi - 8]
                
@@:             mov     dword ptr [edi - 4], ecx
                mov     byte ptr [edi + ecx], 0
@@:             sub     ecx, 1
                movzx   eax, byte ptr [esi + ecx]
                mov     byte ptr [edi + ecx], al
                jnz     short @B                

                ret
RclRclCpy       endp
;--------------------------------------------------------
; The strings must be defined like this:
;                                           dd X
;                                           dd 0
;                                   string  db X+1 dup (0)
;
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 16
CpyRclRcl       proc    pRcl:DWORD, pCpy:DWORD
                push    esi
                push    edi
                mov     esi, [esp + 12]
                mov     edi, [esp + 16]
                call    RclRclCpy
                pop     edi
                pop     esi
                ret     8
CpyRclRcl       endp
;--------------------------------------------------------
; The strings must be defined like this:
;                                           dd X
;                                           dd 0
;                                   string  db X+1 dup (0)
;
align 16
RclRclAdd       proc    pRcl:DWORD, pAdd:DWORD

                mov     esi, [esp + 4]                  ; pRcl
                mov     edi, [esp + 8]                  ; pAdd
                ;
                mov     ecx, dword ptr [esi - 4]
                cmp     ecx, 0
                jne     short @F
                ret     8
                ;             
@@:             mov     edx, dword ptr [edi - 8]                
                mov     eax, dword ptr [edi - 4]
                add     eax, ecx 
                cmp     eax, edx
                jbe     short @F
                ret     8
                ;             
@@:             mov     ebx, edi
                add     ebx, dword ptr [edi - 4]

                mov     dword ptr [edi - 4], eax
                mov     byte ptr [ebx + ecx], 0                
                ; 
@@:             sub     ecx, 1
                movzx   eax, byte ptr [esi + ecx]
                mov     byte ptr [ebx + ecx], al
                jnz     short @B                

                ret     8
RclRclAdd       endp
;--------------------------------------------------------
; The strings must be defined like this:
;                                           dd X
;                                           dd 0
;                                   string  db X+1 dup (0)
align 4
CnvToRcl    proc    Val:DWORD, pRcl:DWORD
            push    ebx
            push    esi
            push    edi

            mov     eax, [esp+16]           ; Val
            mov     edi, [esp+20]           ; pBuf
            
            test    eax, eax
            jnz     short @F
            
            mov     dword ptr [edi - 4], 1
            mov     word ptr [edi], 30h
            clc
            jnc     _exit

@@:
            mov     ecx, 3435973837
            xor     esi, esi
                        
@@:             mov     ebx, eax
                mul     ecx
                shr     edx, 3
                mov     eax, edx
                lea     edx, [edx*4+edx]
                add     edx, edx
                sub     ebx, edx
                add     bl, '0'
                ;
                push    ebx                 ; To stack
                add     esi, 1
            or      eax, eax
            jnz     short @B
            
            ; Buffer length control 
            cmp     esi, dword ptr [edi - 8]
            jbe     short _go
            ;
@@:         pop     eax                     ; Get from stack
            sub     esi, 1
            jnz     short @B            
            ;
            ; Overflow
            ; 
            mov     ecx, dword ptr [edi - 8]            
            mov     dword ptr [edi - 4], ecx            
            mov     byte ptr [edi + ecx], 0           ; terminate the string
            
@@:         sub     ecx, 1
            mov     byte ptr [edi + ecx], '*'
            jnz     short @B
            stc
            jc      short _exit
            ;
            
_go:        mov     dword ptr [edi - 4], esi
                         
@@:         pop     eax                     ; Get from stack
            mov     byte ptr [edi], al
            add     edi, 1
            sub     esi, 1
            jnz     short @B            

            mov     byte ptr [edi], 0           ; terminate the string
            clc
            
_exit:      pop     edi
            pop     esi
            pop     ebx
            ret     8
CnvToRcl    endp
;--------------------------------------------------------
; The strings must be defined like this:
;                                           dd X
;                                           dd 0
;                                   string  db X+1 dup (0)
align 4
ToRclCnv    proc    Sig:DWORD, Val:DWORD, pRcl:DWORD
            push    ebx
            push    esi
            push    edi

            mov     eax, [esp+20]           ; Val
            mov     edi, [esp+24]           ; pBuf
            mov     ebx, [esp+16]           ; Sig
            mov     Signal, ebx
            
            test    eax, eax
            jnz     short @F
            
            mov     dword ptr [edi - 4], 1
            mov     word ptr [edi], 30h
            clc
            jnc     _exit

@@:
            mov     ecx, 3435973837
            xor     esi, esi
                        
@@:             mov     ebx, eax
                mul     ecx
                shr     edx, 3
                mov     eax, edx
                lea     edx, [edx*4+edx]
                add     edx, edx
                sub     ebx, edx
                add     bl, '0'
                ;
                push    ebx                 ; To stack
                add     esi, 1
            or      eax, eax
            jnz     short @B
            
            ; Buffer length control 
            cmp     esi, dword ptr [edi - 8]
            jb      short _go
            ;
@@:         pop     eax                     ; Get from stack
            sub     esi, 1
            jnz     short @B            
            ;
            ; Overflow
            ; 
            mov     ecx, dword ptr [edi - 8]            
            mov     dword ptr [edi - 4], ecx            
            mov     byte ptr [edi + ecx], 0           ; terminate the string
            
@@:         sub     ecx, 1
            mov     byte ptr [edi + ecx], '*'
            jnz     short @B
            stc
            jc      short _exit
            ;
            
_go:        mov     dword ptr [edi - 4], esi
            
            cmp     Signal, 0
            je      short @F

            mov     eax, esi
            add     eax, 1
            mov     dword ptr [edi - 4], eax

            mov     byte ptr [edi], '-'
            add     edi, 1        
                                     
@@:         pop     eax                     ; Get from stack
            mov     byte ptr [edi], al
            add     edi, 1
            sub     esi, 1
            jnz     short @B            

            mov     byte ptr [edi], 0           ; terminate the string
            clc
            
_exit:      pop     edi
            pop     esi
            pop     ebx
            ret     12
ToRclCnv    endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
;
; The strings must be defined like this:
;                                           dd X
;                                           dd 0
;                                   string  db X+1 dup (0)
align 4
dwtoa       proc    dwValue:DWORD, pRcl:DWORD
            push    ebx
            push    esi
            push    edi

            mov     eax, dwValue
            mov     edi, pRcl

            test    eax, eax
            jnz     sign

  zero:
            mov     word ptr [edi],30h
            mov     dword ptr [edi - 4], 1
            jmp     dtaexit
  sign:     
            jns     pos
            mov     byte ptr [edi],'-'
            neg     eax
            add     edi, 1

  pos:
            mov ecx, 3435973837
            mov esi, edi

            .while (eax > 0)
                mov ebx,eax
                mul ecx
                shr edx, 3
                mov eax,edx
                lea edx,[edx*4+edx]
                add edx,edx
                sub ebx,edx
                add bl,'0'
                mov [edi],bl
                add edi, 1
            .endw

            mov     byte ptr [edi], 0       ; terminate the string

            mov     ebx, pRcl
            mov     eax, edi
            sub     eax, ebx
            mov     dword ptr [ebx - 4], eax
            
            ; We now have all the digits, but in reverse order.

            .while (esi < edi)
                sub edi, 1
                mov al, [esi]
                mov ah, [edi]
                mov [edi], al
                mov [esi], ah
                add esi, 1
            .endw

  dtaexit:

            pop edi
            pop esi
            pop ebx
            ret
dwtoa       endp
;........................................................
PrintVar        proc    Var:DWORD
                pushfd
                pushad

                mov     eax, Var
                invoke  dwtoa, eax, addr VarBuffer
                invoke  StandardOut, addr VarBuffer

                popad
                popfd                
                ret
PrintVar        endp
;........................................................
PrintVarLF      proc    Var:DWORD
                pushfd
                pushad

                mov     eax, Var
                invoke  dwtoa, eax, addr VarBuffer
                invoke  StandardOut, addr VarBuffer
                invoke  StandardOut, offset _RTLF

                popad
                popfd                
                ret
PrintVarLF      endp
;........................................................
PrintStringLF   proc    pStr:DWORD
                pushfd
                pushad

                invoke  StandardOut, pStr
                invoke  StandardOut, offset _RTLF

                popad
                popfd                
                ret
PrintStringLF   endp
;........................................................
PrintString     proc    pStr:DWORD
                pushfd
                pushad

                invoke  StandardOut, pStr

                popad
                popfd                
                ret
PrintString     endp
;
; The strings must be defined like this:
;                                           dd X
;                                           dd Len
;                                   string  db X+1 dup (0)
;
; Output:
;           clc:    EAX = dword
;           
;           stc:    error/overflow
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
CnvToDW         proc    pRcl:DWORD
                push    ecx
                push    esi
                push    edi

                mov     esi, [esp + 16]         ; pRcl
                mov     ecx, dword ptr [esi - 4]
                cmp     ecx, 0
                jne     short @F
                ;
zero:           mov     eax, 0
                jmp     _exit

@@:             xor     edi, edi                ; total

next:           movzx   ebx, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                ;
                sub     bl, 30h
                mov     eax, 10
                mul     edi
                jc      short _overflow
                ;
                add     eax, ebx
                jnc     short @F
                ;---------------------
_overflow:      stc
                pop     edi
                pop     esi
                pop     ecx
                ret     4 
                ;----------------------
@@:             mov     edi, eax                
                cmp     ecx, 0
                jne     short next
                ;
_exit:          clc
                pop     edi
                pop     esi
                pop     ecx
                ret     4
CnvToDW         endp
;
; The strings must be defined like this:
;                                           dd X
;                                           dd Len
;                                   string  db X+1 dup (0)
;
; Output:
;           clc:    EAX = signed integer
;           
;           stc:    error/overflow
;
CnvToInt        proc    pRcl:DWORD
                push    ebp
                push    esi
                push    edi

                xor     edi, edi                ; total

                mov     esi, [esp + 16]         ; pRcl
                mov     ecx, dword ptr [esi - 4]
                cmp     ecx, 0
                jne     short @F
                ;
zero:           mov     eax, 0
                jmp     _exit

@@:             mov     ebp, 1                  ; 0 => sign = +
                movzx   ebx, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                cmp     bl, "-"
                je      short @F
                
                xor     ebp, ebp                ; 0 => sign = +
                cmp     bl, "+"
                jne     short _start
                                
@@:             cmp     ecx, 0
                je      zero

next:           movzx   ebx, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                ;
_start:         sub     bl, 30h
                mov     eax, 10
                mul     edi
                add     eax, ebx
                jns     short @F
                ;---------------------
                cmp     ecx, 0
                jne     short _overflow
                ;
                cmp     eax, 80000000h
                jne     short _overflow
                ;
                cmp     ebp, 1    
                je      short _exit
                ;
_overflow:      stc
                pop     edi
                pop     esi
                pop     ebp
                ret     4 
                ;----------------------
@@:             mov     edi, eax                
                cmp     ecx, 0
                jne     short next
                ;
                cmp     ebp, 0
                je      short _exit
                ;
                neg     eax
                ;
_exit:          clc
                pop     edi
                pop     esi
                pop     ebp
                ret     4
CnvToInt        endp
;
; The strings must be defined like this:
;                                           dd X
;                                           dd Len
;                                   string  db X+1 dup (0)
; Output:
;           clc:    EAX = signed integer
;           
;           stc:     overflow
;
ToIntCnv        proc    pRcl:DWORD, Sig:DWORD
                push    ebp
                push    esi
                push    edi

                xor     edi, edi                ; total

                mov     esi, [esp + 16]         ; pRcl
                mov     ebp, [esp + 20]         ; Sign ; 0 => sign +   1 => sign -
                mov     ecx, dword ptr [esi - 4]
                cmp     ecx, 0
                jne     short next
                ;
zero:           mov     eax, 0
                jmp     _exit

next:           movzx   ebx, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                ;
_start:         sub     bl, 30h
                mov     eax, 10
                mul     edi
                add     eax, ebx
                jns     short @F
                ;---------------------
                cmp     ecx, 0
                jne     short _overflow
                
                cmp     eax, 80000000h
                jne     short _overflow
                
                cmp     ebp, 1    
                je      short _exit
                ;
_overflow:      stc
                pop     edi
                pop     esi
                pop     ebp
                ret     8 
                ;----------------------
@@:             mov     edi, eax                
                cmp     ecx, 0
                jne     short next
                ;
                cmp     ebp, 0
                je      short _exit
                ;
                neg     eax
                ;
_exit:          clc
                pop     edi
                pop     esi
                pop     ebp
                ret     8
ToIntCnv        endp
;
; Output:
;           clc:    EAX = signed integer
;           
;           stc:    overflow
;
CvToInt         proc    pStr:DWORD, Len:DWORD
                push    ebp
                push    esi
                push    edi

                xor     edi, edi                ; total

                mov     esi, [esp + 16]         ; pStr
                mov     ecx, [esp + 20]         ; Len
                cmp     ecx, 0
                jne     short @F
                ;
zero:           mov     eax, 0
                jmp     _exit

@@:             mov     ebp, 1                  ; 1 => sign = -
                movzx   ebx, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                cmp     bl, "-"
                je      short @F
                
                xor     ebp, ebp                ; 0 => sign = +
                cmp     bl, "+"
                jne     short _start
                                
@@:             cmp     ecx, 0
                je      zero

next:           movzx   ebx, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                ;
_start:         sub     bl, 30h
                mov     eax, 10
                mul     edi
                add     eax, ebx
                jns     short @F
                ;---------------------
                cmp     ecx, 0
                jne     short _overflow
                ;
                cmp     eax, 80000000h
                jne     short _overflow
                ;
                cmp     ebp, 1    
                je      short _exit
                ;
_overflow:      stc
                pop     edi
                pop     esi
                pop     ebp
                ret     8 
                ;----------------------
@@:             mov     edi, eax                
                cmp     ecx, 0
                jne     short next
                ;
                cmp     ebp, 0
                je      short _exit
                ;
                neg     eax
                ;
_exit:          clc
                pop     edi
                pop     esi
                pop     ebp
                ret     8
CvToInt         endp
;
RemoveZero      proc    pRcl:DWORD
                push    ecx
                push    esi
                ;
                mov     esi, [esp + 12]
                mov     ebx, esi
                mov     ecx, dword ptr [esi - 4]
                
                cmp     ecx, 0
                je      short _end
                ;
@@:             movzx   eax, byte ptr [esi]
                ;
                cmp     al, '0'
                jne     _exit

                add     esi, 1
                
                sub     ecx, 1
                jnz     short @B
                ;
                mov     dword ptr [ebx - 4], 1
                mov     byte ptr [ebx + 1], 0
                ;
                pop     esi
                pop     ecx
                ret     4     

_exit:          cmp     esi, ebx
                je      _end

                mov     dword ptr [ebx - 4], ecx
                
@@:             movzx   eax, byte ptr [esi]
                mov     byte ptr [ebx], al
                ;
                add     esi, 1
                add     ebx, 1
                sub     ecx, 1
                jnz     short @B
                ;
                mov     byte ptr [ebx], 0                
                ;
_end:           pop     esi
                pop     ecx     
                ret     4
RemoveZero      endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
;
StandardOut     proc        pText:DWORD
                LOCAL       StdHandle:DWORD
                LOCAL       Written :DWORD

                invoke      GetStdHandle, STD_OUTPUT_HANDLE
                mov         StdHandle, eax

                invoke      GetStrLen, pText

                invoke      WriteFile, StdHandle, pText, ecx, ADDR Written, 0
                mov         eax, Written
                ret
StandardOut     endp
;-------------------------------------------------------
StandardIn      proc        pBuffer:DWORD, Len:DWORD
                LOCAL       StdHandle :DWORD
                LOCAL       Read  :DWORD

                invoke      GetStdHandle, STD_INPUT_HANDLE
                mov         StdHandle, eax

                invoke      SetConsoleMode, StdHandle, STANDARDINPUT

                invoke      ReadFile, StdHandle, pBuffer, Len, ADDR Read, 0

                mov         eax, Read
                ret
StandardIn      endp                
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
GetStrLen       proc    pStr:DWORD

                mov     edx, [esp + 4]          ;pStr
                xor     ecx, ecx
                jz      short @F
            
next:           add     ecx, 1            
@@:             movzx   eax, byte ptr [edx + ecx]
                cmp     al, 0
                jne     short next

                ret     4
GetStrLen       endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef
;
; Input:
;           Sin1,2  =0  sign +       
;                   =1  sign -
;
;           Opr:     1=Sub    2=Add    3=Mul   4=Div   5= Rem
;
; Output:
;           clc:
;                   EAX     - result
;                   ECX     - signal
;
;           stc:
;                   EAX = 0     => overflow
;                         1     => error
;
OperateXY       proc    Sin1:DWORD, Val1:DWORD, Sin2:DWORD, Val2:DWORD, Opr:DWORD
                LOCAL   Sign:DWORD
                ;
                mov     eax, Sin1
                mov     dl, al
                mov     Sign, eax
                ;
                mov     dh, byte ptr Sin2
                                
                mov     ebx, Val1
                mov     ecx, Val2

                mov     eax, Opr

                    cmp     eax, 3
                    jae     _case3
                
                    cmp     eax, 2
                    je      short _case2

                        mov     al, 1
                                                
                        cmp     dh, 0
                        je      short @F

                        mov     al, 0
                        
                @@:     mov     dh, al
                
          _case2:       cmp     dl, dh
                        je      short _add
                        
                        cmp     ebx, ecx
                        jae     short _sub
                        ;
                        movzx   eax, dh
                        mov     dword ptr Sign, eax        ; 0 = +     1 = -
                        xchg    ebx, ecx
                        
           _sub:        sub     ebx, ecx
                        jmp     _exit
                        
           _add:        add     ebx, ecx
                        jc      erro1                        
                        jnc     _exit
                        
          _case3:       mov     dword ptr Sign, 0 ; 0 = +     1 = -

                        cmp     dl, dh
                        je      short @F

                        mov     dword ptr Sign, 1 ; 0 = +     1 = -

              @@:   cmp     eax, 3                  ; Mul
                    jne     _case4          

                        mov     eax, ebx
                        mul     ecx
                        jc      erro1
                        
                        mov     ebx, eax

                    jmp     _exit                        
          _case4:   cmp     eax, 4                  ; Div
                    jne     _case5
                    
                        cmp     ecx, 0
                        je      erro2

                        xor     edx, edx
                        mov     eax, ebx
                        div     ecx
                        mov     ebx, eax

                    jmp     _exit                                                
          _case5:   cmp     eax, 5                  ; Remainder
                    jne     erro2

                        cmp     ecx, 0
                        je      erro2

                        xor     edx, edx                        
                        mov     eax, ebx
                        div     ecx
                        mov     ebx, edx
                
_exit:          mov     eax, ebx
                mov     ecx, Sign
                clc
                ret
                
erro1:          mov     eax, 0
                stc
                ret
erro2:          mov     eax, 1
                stc
                ret
OperateXY       endp
;
